#!/bin/bash
# Create virtnet topology 1

echo 'You are about to clone the "base" VM to node(s). Make sure you'
echo 'have deleted any existing nodes before continuing. In the '
echo 'VirtualBox GUI, if you have node1, node2, ... then right-click'
echo 'on them and select "Remove..." and then "Delete all files". '
echo 'They need to be deleted before continuing.'

read -n1 -r -p "Press any key to continue..." key

# Shortcut to the Virutal Box manager executable
vbm="VBoxManage"

# Clone and configure each node

# Node 1
${vbm} clonevm base --name node1 --snapshot base --options link --register
${vbm} modifyvm node1 --cableconnected2 off
${vbm} modifyvm node1 --cableconnected3 off
${vbm} modifyvm node1 --nic2 intnet --intnet2 neta
${vbm} modifyvm node1 --cableconnected2 on
${vbm} modifyvm node1 --natpf1 delete ssh
${vbm} modifyvm node1 --natpf1 ssh,tcp,,2201,,22

read -n1 -r -p "Press any key to continue..." key

echo 'You should now have the following new VMs in VirtualBox:'
echo '   node1'
echo 'If not, then make sure you deleted an OLD node1 VMs before '
echo 'running this command. '
echo 'You should now do the following for each node created:'
echo '   1. Start "node1" in VirtualBox'
echo '   2. Login with username "network" and password "network"'
echo '   3. Run the command:'
echo '      sudo bash virtnet/bin/vn-deploynode 1 1'
echo 'Perform the above steps now. Once completed, press any key to quit.'

read -n1 -r -p "Press any key to continue..." key
